/*******************************************************
This program was created by the
CodeWizardAVR V3.12 Advanced
Automatic Program Generator
 Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 13.01.2015
Author  : 
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*******************************************************/

#include <mega8.h>
#include <delay.h>

void Ports_initialization(void);
void Timer0_initialization(void);
void Timer1_initialization(void);
void Timers_Interrupts_initialization(void);
void External_INT0_initialization(void);

  unsigned char kn_max = 1; 
  unsigned char kn_min = 1;
  unsigned char pover = 0xD8; //= 216; //

// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
{
    // Place your code here
    TCNT0=pover;
    TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (0<<CS12) | (0<<CS11) | (0<<CS10);
    TCNT1H=0xD8F0 >> 8;
    TCNT1L=0xD8F0 & 0xff;
    TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (0<<CS12) | (1<<CS11) | (0<<CS10);
}

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
    // Reinitialize Timer 0 value

    // Place your code here
    PORTD=(0<<PORTD1) | (0<<PORTD0);
    //delay_us(30);
    #asm("nop");
    #asm("nop");
    #asm("nop");
    #asm("nop");
    PORTD=(1<<PORTD1) | (1<<PORTD0);
}


// Timer1 overflow interrupt service routine
// 10 ms
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
    // Reinitialize Timer1 value
    TCNT0 = pover;

    // Place your code here
    //PORTB=!PORTB;
    DDB0 = !DDB0;
}




void main(void)
{
    // Declare your local variables here

    Ports_initialization();
    Timer0_initialization();
    Timer1_initialization();
    
    Timers_Interrupts_initialization();
    External_INT0_initialization();
    // Global enable interrupts
    #asm("sei")

    while (1)
    {
      kn_max=PINC.0;       
      kn_min=PINC.1;

      if(kn_max<1){
        pover=pover+1;
        if(pover>250){
           pover=250;
        };
        delay_ms(16); 
      }   

         if(kn_min<1){
           pover=pover-1;
           if(pover<180) {
             pover=180;
           };
           
           delay_ms(16);     
         };

    };
}





//-----------------------------------------
//         Timer0 initialization
//-----------------------------------------
// Clock source: System Clock
// Clock value: 7,813 kHz
void Timer0_initialization(void)
{
    TCCR0=(1<<CS02) | (0<<CS01) | (1<<CS00);
    TCNT0=0xB2;
}


//-------------------------------------------
//          Timer1 initialization
//   50 = 20 ms -  
//   20/2 = 10 ms -   
//-------------------------------------------
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: Normal top=0xFFFF
// OC1A output: Disconnected
// OC1B output: Disconnected
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer Period: 10 ms
// Timer1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
void Timer1_initialization(void)
{
    TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
    TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (0<<CS12) | (1<<CS11) | (0<<CS10);
    TCNT1H=0xD8;
    TCNT1L=0xF0;
    ICR1H=0x00;
    ICR1L=0x00;
    OCR1AH=0x00;
    OCR1AL=0x00;
    OCR1BH=0x00;
    OCR1BL=0x00;
}



//-------------------------------------------------
//      External Interrupt(s) initialization
//-------------------------------------------------
// INT0: On
// INT0 Mode: Low level
// INT1: Off
void External_INT0_initialization(void)
{
    GICR|=(0<<INT1) | (1<<INT0);
    MCUCR=(0<<ISC11) | (0<<ISC10) | (1<<ISC01) | (1<<ISC00);
    GIFR=(0<<INTF1) | (1<<INTF0);
}

//----------------------------------------------
//      Timers Interrupts initialization
//----------------------------------------------
void Timers_Interrupts_initialization(void)
{
    TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (1<<TOIE1) | (1<<TOIE0);
}




//----------------------------------------------
//      Input/Output Ports initialization
//----------------------------------------------
void Ports_initialization(void)
{
    // Port B initialization
    // Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=Out Bit2=Out Bit1=Out Bit0=Out 
    DDRB=(0<<DDB7) | (0<<DDB6) | (0<<DDB5) | (0<<DDB4) | (1<<DDB3) | (1<<DDB2) | (1<<DDB1) | (1<<DDB0);
    // State: Bit7=T Bit6=T Bit5=T Bit4=T Bit3=0 Bit2=0 Bit1=0 Bit0=0 
    PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

    // Port C initialization
    // Function: Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
    DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (0<<DDC2) | (0<<DDC1) | (0<<DDC0);
    // State: Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
    PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (1<<PORTC1) | (1<<PORTC0);

    // Port D initialization
    // Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=In Bit2=In Bit1=In Bit0=In 
    DDRD=(0<<DDD7) | (0<<DDD6) | (0<<DDD5) | (0<<DDD4) | (0<<DDD3) | (0<<DDD2) | (1<<DDD1) | (1<<DDD0);
    // State: Bit7=T Bit6=T Bit5=T Bit4=T Bit3=T Bit2=T Bit1=T Bit0=T 
    PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);
}


